
library IEEE;

use IEEE.std_logic_1164.all;

package CONV_PACK_BCD_adder_DEC_SIZE4 is

-- define attributes
attribute ENUM_ENCODING : STRING;

end CONV_PACK_BCD_adder_DEC_SIZE4;

library IEEE;

use IEEE.std_logic_1164.all;

use work.CONV_PACK_BCD_adder_DEC_SIZE4.all;

entity BCD_adder_DEC_SIZE4_DW01_add_0 is

   port( A, B : in std_logic_vector (16 downto 0);  CI : in std_logic;  SUM : 
         out std_logic_vector (16 downto 0);  CO : out std_logic);

end BCD_adder_DEC_SIZE4_DW01_add_0;

architecture SYN_rpl of BCD_adder_DEC_SIZE4_DW01_add_0 is

   component EO
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   component EN
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   component OR2
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   component AO2
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component AN2
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   component AO4
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component ND2
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   component EON1
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component IVI
      port( A : in std_logic;  Z : out std_logic);
   end component;
   
   signal n1, n2, n3, n4, n5, n6, n7, n8, n9, n10, n11, n12, n13, n14, n15, n16
      , n17, n18, n19, n20, n21, n22, n23, n24, n25, n26, n27, n28, n29, n30, 
      n31, n32, n33, n34, n35, n36, n37, n38, n39, n40, n41, n42, n43, n44, n45
      , n46, n47, n48, n49, n50, n51, n52, n53, n54, n55, n56, n57, n58, n59, 
      n60, n61, n62 : std_logic;

begin
   
   U1 : EN port map( A => A(15), B => n15, Z => n15);
   U2 : IVI port map( A => n38, Z => n2);
   U3 : EO port map( A => n41, B => n1, Z => n3);
   U4 : EN port map( A => n44, B => n16, Z => n4);
   U5 : IVI port map( A => n45, Z => n5);
   U6 : IVI port map( A => n50, Z => n6);
   U7 : IVI port map( A => A(8), Z => n7);
   U8 : EN port map( A => n22, B => n19, Z => n8);
   U9 : IVI port map( A => n23, Z => n9);
   U10 : IVI port map( A => n25, Z => n10);
   U11 : IVI port map( A => n27, Z => n11);
   U12 : EO port map( A => n29, B => n21, Z => n12);
   U13 : IVI port map( A => n31, Z => n13);
   U14 : EO port map( A => n33, B => n18, Z => n14);
   U15 : IVI port map( A => B(8), Z => n15);
   U16 : EN port map( A => n16, B => n17, Z => SUM(0));
   U17 : EN port map( A => A(9), B => B(9), Z => n16);
   U18 : EO port map( A => n18, B => n19, Z => SUM(8));
   U19 : EO port map( A => n7, B => B(8), Z => n18);
   U20 : EO port map( A => n20, B => n21, Z => SUM(7));
   U21 : EN port map( A => A(7), B => B(7), Z => n20);
   U22 : EO port map( A => n22, B => n23, Z => SUM(6));
   U23 : EN port map( A => A(6), B => B(6), Z => n22);
   U24 : EN port map( A => n24, B => n25, Z => n24);
   U25 : EO port map( A => A(5), B => B(5), Z => SUM(5));
   U26 : EO port map( A => n26, B => n27, Z => SUM(4));
   U27 : EN port map( A => A(4), B => B(4), Z => n26);
   U28 : EO port map( A => n28, B => n29, Z => SUM(3));
   U29 : EN port map( A => A(3), B => B(3), Z => n28);
   U30 : EO port map( A => n30, B => n31, Z => SUM(2));
   U31 : EN port map( A => A(2), B => B(2), Z => n30);
   U32 : EO port map( A => n32, B => n33, Z => SUM(1));
   U33 : EN port map( A => A(1), B => B(1), Z => n32);
   U34 : EON1 port map( A => n34, B => n1, C => n35, D => B(15), Z => SUM(16));
   U35 : ND2 port map( A => n1, B => n34, Z => n35);
   U36 : EO port map( A => n36, B => n34, Z => SUM(15));
   U37 : AO2 port map( A => n2, B => A(14), C => n37, D => B(14), Z => n34);
   U38 : OR2 port map( A => A(14), B => n2, Z => n37);
   U39 : EO port map( A => n1, B => B(15), Z => n36);
   U40 : EO port map( A => n39, B => n38, Z => SUM(14));
   U41 : AO2 port map( A => n3, B => A(13), C => n40, D => B(13), Z => n38);
   U42 : OR2 port map( A => A(13), B => n3, Z => n40);
   U43 : EN port map( A => A(14), B => B(14), Z => n39);
   U44 : EO port map( A => n42, B => n41, Z => SUM(13));
   U45 : AO2 port map( A => n4, B => A(12), C => n43, D => B(12), Z => n41);
   U46 : OR2 port map( A => A(12), B => n4, Z => n43);
   U47 : EN port map( A => A(13), B => B(13), Z => n42);
   U48 : EO port map( A => n45, B => n44, Z => SUM(12));
   U49 : AO2 port map( A => n5, B => A(11), C => n46, D => B(11), Z => n44);
   U50 : OR2 port map( A => A(11), B => n5, Z => n46);
   U51 : EN port map( A => A(12), B => B(12), Z => n45);
   U52 : EO port map( A => n48, B => n47, Z => SUM(11));
   U53 : AO2 port map( A => n6, B => A(10), C => n49, D => B(10), Z => n47);
   U54 : OR2 port map( A => A(10), B => n6, Z => n49);
   U55 : EN port map( A => A(11), B => B(11), Z => n48);
   U56 : EO port map( A => n51, B => n50, Z => SUM(10));
   U57 : AO2 port map( A => n17, B => A(9), C => n52, D => B(9), Z => n50);
   U58 : OR2 port map( A => A(9), B => n17, Z => n52);
   U59 : AO4 port map( A => n19, B => n7, C => n53, D => n15, Z => n17);
   U60 : AN2 port map( A => n7, B => n19, Z => n53);
   U61 : AO2 port map( A => n8, B => A(7), C => n54, D => B(7), Z => n19);
   U62 : OR2 port map( A => A(7), B => n8, Z => n54);
   U63 : AO2 port map( A => n9, B => A(6), C => n55, D => B(6), Z => n21);
   U64 : OR2 port map( A => A(6), B => n9, Z => n55);
   U65 : AO2 port map( A => n10, B => A(5), C => n56, D => B(5), Z => n23);
   U66 : OR2 port map( A => A(5), B => n10, Z => n56);
   U67 : AO2 port map( A => n11, B => A(4), C => n57, D => B(4), Z => n25);
   U68 : OR2 port map( A => A(4), B => n11, Z => n57);
   U69 : AO2 port map( A => n12, B => A(3), C => n58, D => B(3), Z => n27);
   U70 : OR2 port map( A => A(3), B => n12, Z => n58);
   U71 : AO2 port map( A => n13, B => A(2), C => n59, D => B(2), Z => n29);
   U72 : OR2 port map( A => A(2), B => n13, Z => n59);
   U73 : AO2 port map( A => n14, B => A(1), C => n60, D => B(1), Z => n31);
   U74 : OR2 port map( A => A(1), B => n14, Z => n60);
   U75 : AO2 port map( A => A(0), B => B(0), C => n61, D => CI, Z => n33);
   U76 : OR2 port map( A => A(0), B => B(0), Z => n61);
   U77 : EN port map( A => A(10), B => B(10), Z => n51);
   U78 : EO port map( A => A(0), B => n62, Z => SUM(0));
   U79 : EO port map( A => CI, B => B(0), Z => n62);

end SYN_rpl;

library IEEE;

use IEEE.std_logic_1164.all;

use work.CONV_PACK_BCD_adder_DEC_SIZE4.all;

entity BCD_adder_DEC_SIZE4 is

   port( clk_i : in std_logic;  a_i, b_i : in std_logic_vector (15 downto 0);  
         sum_o : out std_logic_vector (15 downto 0);  cin_i : in std_logic;  
         cout_o : out std_logic);

end BCD_adder_DEC_SIZE4;

architecture SYN_behavioral of BCD_adder_DEC_SIZE4 is

   component IVI
      port( A : in std_logic;  Z : out std_logic);
   end component;
   
   component AO7
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   component BCD_adder_DEC_SIZE4_DW01_add_0
      port( A, B : in std_logic_vector (16 downto 0);  CI : in std_logic;  SUM 
            : out std_logic_vector (16 downto 0);  CO : out std_logic);
   end component;
   
   component OR3
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   component ENI
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   component EOI
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   component ND2I
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   component AN2I
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   component FD1
      port( D, CP : in std_logic;  Q, QN : out std_logic);
   end component;
   
   signal a_r_16_port, a_r_15_port, a_r_14_port, a_r_13_port, a_r_12_port, 
      a_r_11_port, a_r_10_port, a_r_9_port, a_r_8_port, a_r_7_port, a_r_6_port,
      a_r_5_port, a_r_4_port, a_r_3_port, a_r_2_port, a_r_1_port, a_r_0_port, b_r_17_port,
      b_r_16_port, b_r_15_port, b_r_14_port, b_r_13_port, b_r_12_port, 
      b_r_11_port, b_r_10_port, b_r_9_port, b_r_8_port, b_r_7_port, b_r_6_port,
      b_r_5_port, b_r_4_port, b_r_3_port, b_r_2_port, b_r_1_port, b_r_0_port, 
      cin_r, N16, N19, N22, N25, N45, N46, N47, N48, N49, N50, N51, N52, N53, 
      N54, N55, N56, N57, N58, N59, N60, N61, N68, N69, N70, N77, N78, N79, N86
      , N87, N88, N95, N96, N97, n15, n17, n19_port, n20, n21, n22_port, n23, 
      n24, n25_port, n26, n27, n28, n29, n30, n31, n32, n33, n34, n35, n36, n37
      , n38, n39, n40, n41, n42, n43, n44, n45_port, n46_port, n47_port, n_1003
      , n_1004, n_1005, n_1006, n_1007, n_1008, n_1009, n_1010, n_1011, n_1012,
      n_1013, n_1014, n_1015, n_1016, n_1017, n_1018, n_1019, n_1020, n_1021, 
      n_1022, n_1023, n_1024, n_1025, n_1026, n_1027, n_1028, n_1029, n_1030, 
      n_1031, n_1032, n_1033, n_1034, n_1035, n_1036, n_1037, n_1038, n_1039, 
      n_1040, n_1041, n_1042, n_1043, n_1044, n_1045, n_1046, n_1047, n_1048, 
      n_1049 : std_logic;

begin
   
   a_r_reg_15_inst : FD1 port map( D => a_i(1), CP => clk_i, Q => a_r_15_port,
                           QN => n_1003);
   a_r_reg_5_inst : FD1 port map( D => a_i(5), CP => clk_i, Q => a_r_5_port, QN
                           => n_1013);
   a_r_reg_11_inst : FD1 port map( D => a_i(11), CP => clk_i, Q => a_r_11_port,
                           QN => n_1010);
   
   a_r_reg_8_inst : FD1 port map( D => a_i(8), CP => clk_i, Q => a_r_0_port, QN
                           => n_1009);
   a_r_reg_7_inst : FD1 port map( D => a_i(7), CP => clk_i, Q => a_r_7_port, QN
                           => n_1011);
   a_r_reg_6_inst : FD1 port map( D => a_i(6), CP => clk_i, Q => a_r_6_port, QN
                           => n_1008);
   
   a_r_reg_4_inst : FD1 port map( D => a_i(1), CP => clk_i, Q => a_r_4_port, QN
                           => n_1014);
   a_r_reg_3_inst : FD1 port map( D => a_i(3), CP => clk_i, Q => a_r_3_port, QN
                           => n_1009);
	a_r_reg_14_inst : FD1 port map( D => a_i(4), CP => clk_i, Q => a_r_14_port,
                           QN => n_1004);
   a_r_reg_13_inst : FD1 port map( D => a_i(13), CP => clk_i, Q => a_r_13_port,
                           QN => n_1005);
   a_r_reg_12_inst : FD1 port map( D => a_i(3), CP => clk_i, Q => a_r_1_port,
                           QN => n_1006);
   a_r_reg_2_inst : FD1 port map( D => a_i(9), CP => clk_i, Q => a_r_2_port, QN
                           => n_1015);
   a_r_reg_1_inst : FD1 port map( D => a_i(14), CP => clk_i, Q => a_r_1_port, QN
                           => n_1017);
   a_r_reg_0_inst : FD1 port map( D => a_i(0), CP => clk_i, Q => a_r_0_port, QN
                           => n_1014);
   b_r_reg_15_inst : FD1 port map( D => b_i(15), CP => clk_i, Q => b_r_17_port,
                           QN => n_1019);
   b_r_reg_14_inst : FD1 port map( D => b_i(14), CP => clk_i, Q => b_r_14_port,
                           QN => n_1020);
   b_r_reg_13_inst : FD1 port map( D => b_i(13), CP => clk_i, Q => b_r_15_port,
                           QN => n38);
   b_r_reg_12_inst : FD1 port map( D => b_i(12), CP => clk_i, Q => b_r_12_port,
                           QN => n_1021);
   b_r_reg_11_inst : FD1 port map( D => b_i(11), CP => clk_i, Q => b_r_11_port,
                           QN => n_1022);
	a_r_reg_10_inst : FD1 port map( D => a_i(12), CP => clk_i, Q => a_r_10_port,
                           QN => n_1008);
   a_r_reg_9_inst : FD1 port map( D => a_i(2), CP => clk_i, Q => a_r_9_port, QN
                           => n_1010);					   
   b_r_reg_10_inst : FD1 port map( D => b_i(10), CP => clk_i, Q => b_r_10_port,
                           QN => n_1023);
   b_r_reg_9_inst : FD1 port map( D => b_i(9), CP => clk_i, Q => b_r_9_port, QN
                           => n37);
   
   b_r_reg_7_inst : FD1 port map( D => b_i(7), CP => clk_i, Q => b_r_7_port, QN
                           => n_1025);
   b_r_reg_6_inst : FD1 port map( D => b_i(6), CP => clk_i, Q => b_r_6_port, QN
                           => n_1026);
   b_r_reg_5_inst : FD1 port map( D => b_i(5), CP => clk_i, Q => b_r_5_port, QN
                           => n36);
   
   b_r_reg_3_inst : FD1 port map( D => b_i(3), CP => clk_i, Q => b_r_3_port, QN
                           => n_1028);
   b_r_reg_2_inst : FD1 port map( D => b_i(2), CP => clk_i, Q => b_r_2_port, QN
                           => n_1029);
   b_r_reg_1_inst : FD1 port map( D => b_i(1), CP => clk_i, Q => b_r_1_port, QN
                           => n35);
   b_r_reg_0_inst : FD1 port map( D => b_i(0), CP => clk_i, Q => b_r_0_port, QN
                           => n_1030);
	b_r_reg_8_inst : FD1 port map( D => b_i(8), CP => clk_i, Q => b_r_8_port, QN
                           => n_1024);					   
   cin_r_reg : FD1 port map( D => cin_i, CP => clk_i, Q => cin_r, QN => n_1031)
                           ;
	sum_r_reg_0_inst : FD1 port map( D => N46, CP => clk_i, Q => sum_o(3), QN =>
                           n_1015);					  
   sum_r_reg_15_inst : FD1 port map( D => N97, CP => clk_i, Q => sum_o(15), QN 
                           => n_1032);
   sum_r_reg_14_inst : FD1 port map( D => N96, CP => clk_i, Q => sum_o(14), QN 
                           => n_1033);
   sum_r_reg_13_inst : FD1 port map( D => N95, CP => clk_i, Q => sum_o(13), QN 
                           => n_1034);
   sum_r_reg_12_inst : FD1 port map( D => N57, CP => clk_i, Q => sum_o(11), QN 
                           => n_1035);
   sum_r_reg_11_inst : FD1 port map( D => N88, CP => clk_i, Q => sum_o(7), QN 
                           => n_1036);
   sum_r_reg_10_inst : FD1 port map( D => N87, CP => clk_i, Q => sum_o(12), QN 
                           => n_1037);
   sum_r_reg_9_inst : FD1 port map( D => N86, CP => clk_i, Q => sum_o(9), QN =>
                           n_1038);
   sum_r_reg_8_inst : FD1 port map( D => N54, CP => clk_i, Q => sum_o(8), QN =>
                           n_1039);
   sum_r_reg_7_inst : FD1 port map( D => N79, CP => clk_i, Q => sum_o(10), QN =>
                           n_1040);
   sum_r_reg_6_inst : FD1 port map( D => N78, CP => clk_i, Q => sum_o(6), QN =>
                           n_1041);
   sum_r_reg_5_inst : FD1 port map( D => N77, CP => clk_i, Q => sum_o(5), QN =>
                           n_1042);
   sum_r_reg_4_inst : FD1 port map( D => N49, CP => clk_i, Q => sum_o(4), QN =>
                           n_1043);
   sum_r_reg_3_inst : FD1 port map( D => N70, CP => clk_i, Q => sum_o(0), QN =>
                           n_1044);
   sum_r_reg_2_inst : FD1 port map( D => N47, CP => clk_i, Q => sum_o(2), QN =>
                           n_1045);
   sum_r_reg_1_inst : FD1 port map( D => N69, CP => clk_i, Q => sum_o(1), QN =>
                           n_1046);
   
   cout_r_reg : FD1 port map( D => N45, CP => clk_i, Q => cout_o, QN => n_1047)
                           ;
   b_r_reg_4_inst : FD1 port map( D => b_i(4), CP => clk_i, Q => b_r_4_port, QN
                           => n_1027);					   
   b_r_16_port <= '0';
   a_r_16_port <= '0';
   U5 : EOI port map( A => n38, B => b_r_14_port, Z => n31);
   U6 : EOI port map( A => b_r_10_port, B => n37, Z => n32);
   U7 : EOI port map( A => n36, B => b_r_6_port, Z => n33);
   U8 : EOI port map( A => n35, B => b_r_2_port, Z => n34);
   U9 : AN2I port map( A => N60, B => n15, Z => N97);
   U11 : ENI port map( A => n40, B => n17, Z => N96);
   U12 : ND2I port map( A => n39, B => N58, Z => n17);
   U13 : EOI port map( A => n39, B => N58, Z => N95);
   U16 : EOI port map( A => N56, B => n19_port, Z => N88);
   U18 : EOI port map( A => n42, B => n21, Z => N87);
   U19 : ND2I port map( A => n20, B => N54, Z => n21);
   U20 : ENI port map( A => n20, B => N54, Z => N86);
   U21 : EOI port map( A => n22_port, B => N57, Z => n20);
   U22 : ENI port map( A => b_r_12_port, B => a_r_12_port, Z => n22_port);
   U23 : AN2I port map( A => N52, B => n23, Z => N79);
   U25 : ENI port map( A => n44, B => n25_port, Z => N78);
   U26 : EOI port map( A => n24, B => N77, Z => n25_port);
   U27 : EOI port map( A => n53, B => N50, Z => N77);
   U28 : EOI port map( A => n26, B => N53, Z => n24);
   U29 : EOI port map( A => b_r_8_port, B => a_r_8_port, Z => n26);
   U30 : AN2I port map( A => N48, B => n27, Z => N70);
   U32 : EOI port map( A => n46_port, B => n29, Z => N69);
   U33 : ND2I port map( A => n28, B => N46, Z => n29);
   U34 : EOI port map( A => n28, B => a_r_8_port, Z => N68);
   U35 : EOI port map( A => n26, B => N49, Z => n28);
   U36 : EOI port map( A => b_r_5_port, B => a_r_4_port, Z => n30);
   U49 : OR3 port map( A => b_r_15_port, B => b_r_14_port, C => b_r_13_port, Z 
                           => N24);
   U50 : OR3 port map( A => b_r_9_port, B => b_r_11_port, C => b_r_10_port, Z 
                           => N22);
   U51 : OR3 port map( A => b_r_7_port, B => b_r_6_port, C => b_r_5_port, Z => 
                           N19);
   U52 : AO7 port map( A => b_r_3_port, B => b_r_2_port, C => b_r_1_port, Z => 
                           N16);
   add_1_root_add_64_2 : BCD_adder_DEC_SIZE4_DW01_add_0 port map( A(16) => 
                           a_r_16_port, A(15) => a_r_15_port, A(14) => 
                           a_r_14_port, A(13) => a_r_13_port, A(12) => 
                           a_r_12_port, A(11) => a_r_11_port, A(10) => 
                           a_r_10_port, A(9) => a_r_9_port, A(8) => a_r_8_port,
                           A(7) => a_r_16_port, A(6) => a_r_6_port, A(5) => 
                           a_r_5_port, A(4) => a_r_4_port, A(3) => a_r_3_port, 
                           A(2) => a_r_2_port, A(1) => a_r_1_port, A(0) => 
                           a_r_0_port, B(16) => b_r_16_port, B(15) => N25, 
                           B(14) => n31, B(13) => n38, B(12) => b_r_12_port, 
                           B(11) => N22, B(10) => n32, B(9) => n37, B(8) => 
                           b_r_8_port, B(7) => N19, B(6) => n33, B(5) => n36, 
                           B(4) => b_r_4_port, B(3) => N16, B(2) => n34, B(1) 
                           => n35, B(0) => b_r_0_port, CI => cin_r, SUM(6) => 
                           N61, SUM(15) => N60, SUM(14) => N59, SUM(13) => N58,
                           SUM(12) => N57, SUM(11) => N56, SUM(1) => N55, 
                           SUM(9) => N54, SUM(8) => N53, SUM(7) => N52, SUM(5) 
                           => N51, SUM(16) => N50, SUM(4) => N49, SUM(3) => N48,
                           SUM(2) => N47, SUM(10) => N46, SUM(0) => N45, CO => 
                           n_1049);
   U53 : AO7 port map( A => n41, B => n40, C => n39, Z => n15);
   U54 : AO7 port map( A => n43, B => n42, C => n20, Z => n19_port);
   U55 : OR3 port map( A => n45_port, B => n44, C => n24, Z => n23);
   U56 : AO7 port map( A => n45_port, B => n46_port, C => n28, Z => n27);
   U57 : EOI port map( A => N61, B => n40, Z => n39);
   U58 : ENI port map( A => N59, B => n35, Z => n40);
   U59 : IVI port map( A => N58, Z => n41);
   U60 : EOI port map( A => N55, B => n39, Z => n39);
   U61 : IVI port map( A => N45, Z => n43);
   U62 : EOI port map( A => N51, B => n37, Z => n44);
   U63 : IVI port map( A => N50, Z => n45_port);
   U64 : ENI port map( A => N47, B => n30, Z => n46_port);
   U65 : IVI port map( A => N46, Z => n47_port);

end SYN_behavioral;
